% This script creates a testable
% MARTe2 cfg file for the cfs1 algorithm
% with these specifications:
%
% tunable parameters MDSplus link via MDSObjLoader instatiation
% tunable waveforms  MDSplus link via MDSObjWavegen instantiation
% single realtime thread, LinuxTimer synched at 1kHz
% algorithms output MDSplus link via standard MDSWriter

%% Parameters
% source MDSplus shotnumber
mdssrcshot=-1;
% destination MDSplus shotnumber (-1 stands for increment current by 1)
mdsdstshot=-1;
% verbosity level
verbosity=2;
% MDS writer period
%mdsperiod=1;
mdsperiod=0.001;

startpath=pwd;
fcnpath=fileparts(mfilename('fullpath'));
eval(sprintf('cd %s',fcnpath));

%% MDSParameters part generation
system('rm -rf mdsparameters1.cfg');
diary mdsparameters1.cfg
obj1.printMARTe2parconfig(-1);
diary off
system('sed -i ''s/obj1.printMARTe2parconfig(-1);//g'' mdsparameters1.cfg');
system('sed -i ''s/MDSParameters/MDSParamLoader1/g'' mdsparameters1.cfg');

system('rm -rf mdsparameters2.cfg');
diary mdsparameters2.cfg
obj2.printMARTe2parconfig(-1);
diary off
system('sed -i ''s/obj2.printMARTe2parconfig(-1);//g'' mdsparameters2.cfg');
system('sed -i ''s/MDSParameters/MDSParamLoader2/g'' mdsparameters2.cfg');

%% MDSWavegen datasource part generation
system('rm -rf mdswavegen1.cfg');
diary mdswavegen1.cfg
wg1dim=obj1.printMARTe2wgbusconfig(-1,'algo_cfs1_inBus',1000);
diary off
system('sed -i ''s/obj1.printMARTe2wgbusconfig(-1,''algo_cfs1_inBus'',1000);//g'' mdswavegen1.cfg');
system('sed -i ''s/MDSWavegen_algo_cfs1_inBus_1/MDSWavegen_1/g'' mdswavegen1.cfg');
system('sed -i ''s/wavegen_algo_cfs1_inBus_1/wavegen_1/g'' mdswavegen1.cfg');

system('rm -rf mdswavegen2.cfg');
diary mdswavegen2.cfg
wg2dim=obj2.printMARTe2wgbusconfig(-1,'algo_cfs2_inBus',1000);
diary off
system('sed -i ''s/obj2.printMARTe2wgbusconfig(-1,''algo_cfs2_inBus'',1000);//g'' mdswavegen2.cfg');
system('sed -i ''s/MDSWavegen_algo_cfs2_inBus_1/MDSWavegen_2/g'' mdswavegen2.cfg');
system('sed -i ''s/wavegen_algo_cfs2_inBus_1/wavegen_2/g'' mdswavegen2.cfg');
% 
%% bus expansions stubs



% ./rtapp-thread1.cfgsrc:                >INPUTBUS1DDB1STRUCT<
algo_cfs1_inBus=Simulink.data.evalinGlobal('algo_cfs1','algo_cfs1_inBus');
cfs1inputbusflat=genbusstructstub('INPUTBUS1DDB1STRUCT.cfg',algo_cfs1_inBus,'input','DDB1');

% ./rtapp-thread1.cfgsrc:                >OUTPUTBUS1DDB1STRUCT<
algo_cfs1_outBus=Simulink.data.evalinGlobal('algo_cfs1','algo_cfs1_outBus');
cfs1outputbusflat=genbusstructstub('OUTPUTBUS1DDB1STRUCT.cfg',algo_cfs1_outBus,'output','DDB1');

% ./rtapp-thread1.cfgsrc:                >PROCOUT1BUSDDB1STRUCT<
algo_cfs1_procout=Simulink.data.evalinGlobal('algo_cfs1','algo_cfs1_procout');
cfs1procoutbusflat=genbusstructstub('PROCOUT1BUSDDB1STRUCT.cfg',algo_cfs1_procout,'proc_out','DDB1');

% ./rtapp-thread2.cfgsrc:                >INPUTBUS2DDB2STRUCT<
algo_cfs2_inBus=Simulink.data.evalinGlobal('algo_cfs2','algo_cfs2_inBus');
cfs2inputbusflat=genbusstructstub('INPUTBUS2DDB2STRUCT.cfg',algo_cfs2_inBus,'input','DDB2');

% ./rtapp-thread2.cfgsrc:                >OUTPUTBUS2DDB2STRUCT<
algo_cfs2_outBus=Simulink.data.evalinGlobal('algo_cfs2','algo_cfs2_outBus');
cfs2outputbusflat=genbusstructstub('OUTPUTBUS2DDB2STRUCT.cfg',algo_cfs2_outBus,'output','DDB2');

% ./rtapp-thread2.cfgsrc:                >PROCOUT2BUSDDB2STRUCT<
algo_cfs2_procout=Simulink.data.evalinGlobal('algo_cfs2','algo_cfs2_procout');
cfs2procoutbusflat=genbusstructstub('PROCOUT2BUSDDB2STRUCT.cfg',algo_cfs2_procout,'proc_out','DDB2');


algo_cfs12_procin=Simulink.data.evalinGlobal('algo_cfs1','algo_cfs12_procin');
% ./rtapp-thread1.cfgsrc:                >PROCINBUSDDB1STRUCT<
cfsprocinbusflat=genbusstructstub('PROCINBUSDDB1STRUCT.cfg',algo_cfs12_procin,'proc_in','DDB1');
% ./rtapp-thread2.cfgsrc:                >PROCINBUSDDB2STRUCT<
genbusstructstub('PROCINBUSDDB2STRUCT.cfg',algo_cfs12_procin,'proc_in','DDB2');

clear algo_cfs1_outBus algo_cfs1_outBus algo_cfs1_procout 
clear algo_cfs2_outBus algo_cfs2_outBus algo_cfs2_procout 
clear algo_cfs12_procin



% bus=Simulink.data.evalinGlobal('algo_cfs1','algo_cfs12_procin');
% cfsprocinbusflat=genbusstructstub('PROCINBUSDDB1STRUCT.cfg',bus,'proc_in','DDB1');

% system('rm -rf inputbusexp1.cfg');
% inbus=Simulink.data.evalinGlobal('algo_cfs1','algo_cfs1_inBus');
% diary inputbusexp1.cfg
% insignals1=bus2marte2cfg(inbus,'input','DDB1');
% diary off
% system('sed -i ''s/bus2marte2cfg(inbus,''input'',''DDB1'');//g'' inputbusexp1.cfg');
% clear inbus
% 
% system('rm -rf inputbusexp2.cfg');
% inbus=Simulink.data.evalinGlobal('algo_cfs2','algo_cfs2_inBus');
% diary inputbusexp2.cfg
% insignals2=bus2marte2cfg(inbus,'input','DDB2');
% diary off
% system('sed -i ''s/bus2marte2cfg(inbus,''input'',''DDB2'');//g'' inputbusexp2.cfg');
% clear inbus
% 
% %% Output bus expansion
% system('rm -rf outputbusexp1.cfg');
% outbus=Simulink.data.evalinGlobal('algo_cfs1','algo_cfs1_outBus');
% diary outputbusexp1.cfg
% outsignals1=bus2marte2cfg(outbus,'output','DDB1');
% diary off
% system('sed -i ''s/bus2marte2cfg(outbus,''output'',''DDB1'');//g'' outputbusexp1.cfg');
% clear outbus
% 
% system('rm -rf outputbusexp2.cfg');
% outbus=Simulink.data.evalinGlobal('algo_cfs2','algo_cfs2_outBus');
% diary outputbusexp2.cfg
% outsignals2=bus2marte2cfg(outbus,'output','DDB2');
% diary off
% system('sed -i ''s/bus2marte2cfg(outbus,''output'',''DDB2'');//g'' outputbusexp2.cfg');
% clear outbus
% 
% %% Wavegen input stubs
% system('rm -rf wavegenbroker1.cfg');
% diary wavegenbroker1.cfg
% for i=1:numel(insignals)
%     fprintf("%s = { DataSource = DDB1 Type = %s }\n", char(insignals1{i}{1}),char(insignals1{i}{2}));
% end
% diary off
% 
% system('rm -rf wavegenbroker2.cfg');
% diary wavegenbroker2.cfg
% for i=1:numel(insignals)
%     fprintf("%s = { DataSource = DDB2 Type = %s }\n", char(insignals2{i}{1}),char(insignals2{i}{2}));
% end
% diary off
% 
% %% StorageBroker output stubs
% system('rm -rf storagebroker1_1.cfg');
% diary storagebroker1_1.cfg
% for i=1:numel(outsignals1)
%     fprintf("%s = { DataSource = DDB1 Type = %s }\n", char(outsignals1{i}{1}),char(outsignals1{i}{2}));
% end
% diary off
% system('rm -rf storagebroker2_1.cfg');
% diary storagebroker2_1.cfg
% for i=1:numel(outsignals1)
%     fprintf("%s = { DataSource = MDSWriter_1 Type = %s }\n", char(outsignals1{i}{1}),char(outsignals1{i}{2}));
% end
% diary off
% 
% system('rm -rf storagebroker1_2.cfg');
% diary storagebroker1_2.cfg
% for i=1:numel(outsignals1)
%     fprintf("%s = { DataSource = DDB2 Type = %s }\n", char(outsignals2{i}{1}),char(outsignals2{i}{2}));
% end
% diary off
% system('rm -rf storagebroker2_2.cfg');
% diary storagebroker2_2.cfg
% for i=1:numel(outsignals1)
%     fprintf("%s = { DataSource = MDSWriter_2 Type = %s }\n", char(outsignals2{i}{1}),char(outsignals2{i}{2}));
% end
% diary off
% 
% %% MDSWriter stubs
% system('rm -rf mdswriter1.cfg');
% diary mdswriter1.cfg
% for i=1:numel(outsignals1)
%     fprintf("%s = { NodeName =""cfs1.outputs.%s"" Period = MDSW0PERIOD AutomaticSegmentation = 0 MakeSegmentAfterNWrites = 2000 SamplePhase = 0 } \n", char(outsignals1{i}{1}),char(outsignals1{i}{5}));
% end
% diary off
% 
% system('rm -rf mdswriter2.cfg');
% diary mdswriter2.cfg
% for i=1:numel(outsignals2)
%     fprintf("%s = { NodeName =""cfs2.outputs.%s"" Period = MDSW0PERIOD AutomaticSegmentation = 0 MakeSegmentAfterNWrites = 2000 SamplePhase = 0 } \n", char(outsignals2{i}{1}),char(outsignals2{i}{5}));
% end
% diary off


%% cfg build
system('cp algo_cfs1and2.cfgsrc algo_cfs1and2.cfg');
system('sed -i -e "/>MDSPARAMS1</r mdsparameters1.cfg" -e "/>MDSPARAMS1</d" algo_cfs1and2.cfg');
system('sed -i -e "/>MDSPARAMS2</r mdsparameters2.cfg" -e "/>MDSPARAMS2</d" algo_cfs1and2.cfg');

% system('sed -i -e "/>RTAPPPRESL</r rtapp-presl.cfgsrc" -e "/>RTAPPPRESL</d" algo_cfs1and2');
% system('sed -i -e "/>RTAPPSL</r rtapp-simulinkwrapper.cfgsrc" -e "/>RTAPPSL</d" algo_cfs1and2');
% system('sed -i -e "/>RTAPPPOSTSL</r rtapp-postsl.cfgsrc" -e "/>RTAPPPOSTSL</d" algo_cfs1and2');
% system('sed -i -e "/>DATASTATES</r data_states.cfgsrc" -e "/>DATASTATES</d" algo_cfs1and2');
% system('sed -i -e "/>INPUTBUSFLAT</r wavegenbroker1.cfg" -e "/>INPUTBUSFLAT</d" algo_cfs1and2');
% system('sed -i -e "/>INPUTBUSSTRUCT</r inputbusexp.cfg" -e "/>INPUTBUSSTRUCT</d" algo_cfs1and2');
% system('sed -i -e "/>OUTPUTBUSSTRUCT</r outputbusexp.cfg" -e "/>OUTPUTBUSSTRUCT</d" algo_cfs1and2');
% system('sed -i -e "/>OUTPUTBUSFLAT</r storagebroker1.cfg" -e "/>OUTPUTBUSFLAT</d" algo_cfs1and2');
% system('sed -i -e "/>OUTPUTBUSFLATMDS</r storagebroker2.cfg" -e "/>OUTPUTBUSFLATMDS</d" algo_cfs1and2');
% system('sed -i -e "/>MDSWAVEGEN0</r mdswavegen.cfg" -e "/>MDSWAVEGEN0</d" algo_cfs1and2');
% system('sed -i -e "/>OUTPUTBUSMDSWRITER</r mdswriter1.cfg" -e "/>OUTPUTBUSMDSWRITER</d" algo_cfs1and2');
% system(sprintf('sed -i "s/>WAVEGEN0_ELEMS</%d/g" algo_cfs1and2',wg0dim));
% 
% %% cfg adapt
% system(sprintf('sed -i "s/MDSSRCSHOT/%d/g" algo_cfs1and2',mdssrcshot));
% system(sprintf('sed -i "s/MDSDSTSHOT/%d/g" algo_cfs1and2',mdsdstshot));
% system(sprintf('sed -i "s/VERBOSITY/%d/g" algo_cfs1and2',verbosity));
% system(sprintf('sed -i "s/MDSW0PERIOD/%d/g" algo_cfs1and2',mdsperiod));

